var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import stickybits from "stickybits";
var ScrollJacker = /** @class */ (function (_super) {
    __extends(ScrollJacker, _super);
    function ScrollJacker(props) {
        var _this = _super.call(this, props) || this;
        _this.increment = 200;
        _this.height = 500;
        _this.updateCurrentPage = function () {
            if (_this.state.currentPage !== _this.getCurrentPage()) {
                _this.setState({ currentPage: _this.getCurrentPage() });
            }
            _this.setState({ currentProgress: _this.getProgress() });
        };
        _this.state = {
            childrenCount: 0,
            currentPage: 0,
            currentProgress: 0
        };
        return _this;
    }
    ScrollJacker.prototype.componentDidMount = function () {
        var _a = this.props, children = _a.children, stickyOffset = _a.stickyOffset, scrollSensitivity = _a.scrollSensitivity;
        scrollSensitivity = scrollSensitivity < 1 ? 1 : scrollSensitivity;
        scrollSensitivity = scrollSensitivity > 9 ? 9 : scrollSensitivity;
        if (children) {
            this.setState({
                childrenCount: React.Children.count(children)
            });
            this.increment = this.increment * (10 - this.props.scrollSensitivity);
            this.height = this.increment * React.Children.count(children);
        }
        if (window) {
            window.addEventListener("scroll", this.updateCurrentPage);
            stickybits("#STC-sticky-child", {
                stickyBitStickyOffset: stickyOffset || 0
            });
        }
    };
    ScrollJacker.prototype.componentWillUnmount = function () {
        if (window) {
            window.removeEventListener("scroll", this.updateCurrentPage);
        }
    };
    ScrollJacker.prototype.getCurrentPage = function () {
        var childrenCount = this.state.childrenCount;
        if (childrenCount < 2 || this.container.getBoundingClientRect().top > 0) {
            return 0;
        }
        var progress = Math.abs(this.container.getBoundingClientRect().top);
        var output = Math.floor(progress / this.increment);
        if (output > childrenCount - 1) {
            return childrenCount - 1;
        }
        return output;
    };
    ScrollJacker.prototype.getProgress = function () {
        var childrenCount = this.state.childrenCount;
        if (childrenCount < 2 || this.container.getBoundingClientRect().top > 0) {
            return 0;
        }
        var progress = Math.abs(this.container.getBoundingClientRect().top);
        if (progress / this.increment > childrenCount) {
            return 1;
        }
        var output = progress / this.increment - Math.floor(progress / this.increment);
        return output;
    };
    //https://stackoverflow.com/questions/42261783/how-to-assign-the-correct-typing-to-react-cloneelement-when-giving-properties-to
    ScrollJacker.prototype.injectedChildren = function () {
        var _this = this;
        var children = this.props.children;
        return React.Children.map(children, function (x) {
            if (React.isValidElement(x)) {
                return React.cloneElement(x, {
                    currentPage: _this.getCurrentPage(),
                    progress: _this.getProgress()
                });
            }
            return x;
        });
    };
    ScrollJacker.prototype.renderChild = function () {
        var _a = this.props, injectChildren = _a.injectChildren, children = _a.children;
        var currentPage = this.state.currentPage;
        return injectChildren
            ? this.injectedChildren()[currentPage]
            : children[this.getCurrentPage()];
    };
    ScrollJacker.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: this.props.className, ref: function (container) {
                _this.container = container;
            }, style: __assign({}, this.props.style, { height: this.height + this.increment + "px" }) },
            React.createElement("div", { id: "STC-sticky-child" }, this.renderChild())));
    };
    ScrollJacker.defaultProps = {
        scrollSensitivity: 7
    };
    return ScrollJacker;
}(React.Component));
export default ScrollJacker;
